=== debian/changelog ===
libofx (1:0.10.9-1) unstable; urgency=medium

  [ Dylan Aïssi ]
  * New upstream version 0.10.9
  * Update debian/copyright

  [ Debian Janitor ]
  * Avoid explicitly specifying -Wl,--as-needed linker flag.

 -- Dylan Aïssi <daissi@debian.org>  Thu, 10 Nov 2022 10:59:51 +0100
